/*
 	2010/06/09(Wed)
	library.c version 1.0
	Programmed by KOYAMA Yoshiaki
 */

#include "types.h"
#include "iocs.h"
#include "library.h"


/*
 
 */

extern	word _seed;

extern void _calc();

byte _locate_x = 0;
byte _locate_y = 1;

/*
	仮想VRAM
*/
byte _gvram[Y_LINE][X_SIZE];

/*
	仮想VRAM 初期化
*/
void initgvram() {
	byte i, j;

	for (i=0; i<X_SIZE; i++) {
		for (j=0; j<Y_LINE; j++) {
			_gvram[j][i] = 0;
		}
	}
}

/*
	OR
*/
void orgvram(byte xline, byte yline, byte size, byte *address, byte bit) {
	byte i, code, gramflag;
	
	gramflag = bit & GPRINT_GRAM;
	
	for (i=0; i<size; i++) {
		code = _gvram[yline][xline*6+i] | address[i];
		
		address[i] = code;
		if (gramflag != 0) {
			_gvram[yline][xline*6+i] = code;
		}	
	}
}

/*
	AND
*/
void andgvram(byte xline, byte yline, byte size, byte *address, byte bit) {
	byte i, code, gramflag;
	
	gramflag = bit & GPRINT_GRAM;
	
	for (i=0; i<size; i++) {
		code = _gvram[yline][xline*6+i] & address[i];
		
		address[i] = code;
		if (gramflag != 0) {
			_gvram[yline][xline*6+i] = code;
		}	
	}
}

/*
	座標(x,y) に address から 8bit データを size バイト分描画
	bit は描画フラグ sample.c を参照
*/

/*
例）
byte data[15][8] = {
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},	
	{0x00,0x00,0x04,0x02,0x7E,0x00,0x00,0x00},
	{0x00,0x00,0x64,0x52,0x4A,0x44,0x00,0x00},
	{0x00,0x00,0x22,0x4A,0x4A,0x36,0x00,0x00},
	{0x00,0x10,0x18,0x14,0x7E,0x10,0x00,0x00},
	{0x00,0x00,0x2E,0x4A,0x4A,0x32,0x00,0x00},		
	{0x00,0x00,0x3C,0x4A,0x4A,0x32,0x00,0x00},		
	{0x00,0x00,0x02,0x72,0x0A,0x06,0x00,0x00},	
	{0x00,0x00,0x34,0x4A,0x4A,0x34,0x00,0x00},		
	{0x00,0x08,0x3C,0x64,0x26,0x3C,0x10,0x00},
	{0x00,0x42,0x24,0x18,0x18,0x24,0x42,0x00},		
	{0x00,0x7E,0x42,0x5A,0x5A,0x42,0x7E,0x00},	
	{0x00,0x00,0x04,0x52,0x0a,0x04,0x00,0x00},
	{0x00,0x00,0x7e,0x0e,0x0e,0x0e,0x00,0x00},
	{0x00,0x08,0x3C,0x7c,0x3e,0x3c,0x10,0x00}
};

void main(void) {
	byte code;

	byte code;
	byte x, y;
	
	cls();
	initgvram();
	
	x = 0; y = 0;
	gprint8(x,  y,  8, data[8],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
	
	x = 123; y = 39;
	gprint8(x,  y,  8, data[8],  GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);			
}
*/

/* 作業領域 */
byte _patLow[X_SIZE], _patHigh[X_SIZE];

void gprint8(byte x, byte y, byte size, byte *address, byte bit) {
	byte xx, xxx, yy;
	byte shiftLeftY, shiftRightY;
	byte low, high, andLow, andHigh, pLow, pHigh;
	byte i, xsize, orflag, drawflag, px;
	
	xx = x / 6;
	xxx = x - xx * 6;
	
	xsize = xxx + size;
	
	orflag = bit & GPRINT_OR;
	drawflag = bit & GPRINT_DRAW;
	
	for (i=0; i<xxx; i++) {
		if (orflag != 0) {
			_patLow[i] = 0;
			_patHigh[i] = 0;
		} else {
			_patLow[i] = 0xff;
			_patHigh[i] = 0xff;
		}
	}
		
	for (i=xxx; i<xsize; i++) {
		px = i - xxx;
		_patLow[i] = address[px];
		_patHigh[i] = address[px];
	}
	
	yy = y / 8;
	shiftLeftY = y - yy*8;
	shiftRightY = 8 - shiftLeftY;
	
	for (i=0; i<xsize; i++) {
		andLow = andHigh = 0xff;
		
		pLow = _patLow[i];
		pHigh = _patHigh[i];
		
		pLow = pLow << shiftLeftY;
		pHigh = pHigh >> shiftRightY;
		
		low = pLow;
		high = pHigh;
				
		if (orflag == 0) {
			andLow = andLow >> shiftRightY;
			andHigh = andHigh << shiftLeftY;
			low = low | andLow;
			high = high | andHigh;
		}
		
		_patLow[i] = low;
		_patHigh[i] = high;
	}
		
	if ((xx < X_LINE) && (yy < Y_LINE)) {
		
		if ((xx*6+xsize) > X_SIZE) {
			xsize = X_SIZE - xx*6;
		}
		
		if (orflag  != 0) {
			orgvram(xx, yy, xsize, _patLow, bit);
		} else {
			andgvram(xx, yy, xsize, _patLow, bit);
		}
		
		if (drawflag != 0) {
			vram(xx, yy, xsize, _patLow);
		}
		
		if ((shiftLeftY != 0) && ((yy + 1) < Y_LINE)) {			
			
			if (orflag != 0) {
				orgvram(xx, yy+1, xsize, _patHigh, bit);
			} else {
				andgvram(xx, yy+1, xsize, _patHigh, bit);
			}
			
			if (drawflag != 0) {
				vram(xx, yy+1, xsize, _patHigh);
			}	
		}
	}
}

/*
	座標(x, y) に address から 8bit データを xsize、yline 行分描画
	bit は描画フラグ sample.c を参照
*/

/*
例)
byte wall[3][4] = {
	{0x0f, 0x0f, 0x0f, 0x0f},
	{0x0f, 0x0f, 0x0f, 0x0f},
	{0x8f, 0x8f, 0x8f, 0x8c}
};

void main(void) {
	byte code;

	byte code;
	byte x, y;
	
	cls();
	initgvram();
	
	x = 123; y = 0;	
	gprint(x, y, 4,  3, wall[0], GPRINT_OR | GPRINT_DRAW | GPRINT_GRAM);
}

*/
void gprint(byte x, byte y, byte xsize, byte yline, byte *address, byte bit) {
	byte *addr;
	byte i;
	
	addr = address;
	gprint8(x, y, xsize, addr, bit);
	
	for (i=1; i<yline; i++) {
		addr = addr + xsize;
		gprint8(x, y+i*8, xsize, addr, bit);	
	}
}

/*
	仮想VRAMを描画
*/
void drawScreen() {	
	int i;
	
	for (i=0; i<Y_LINE;  i++) {
		vram(0, i, X_SIZE, _gvram[i]);	
	}	
}

/*
	文字表示
*/

/*
	表示位置の設定
*/
void setLocate(byte x, byte y) {
	_locate_x = x;
	_locate_y = y;
}

/*
	1文字表示
*/
void putChar(byte data) {
	printchar(_locate_x, _locate_y, data);
	_calc();
}

/*
	空白を表示
*/
void putSpace() {
	putChar(0x20);
}

/*
	文字列表示
*/
void print(byte *addr) {	
	while (*addr != 0x00) {
		putChar(*addr);
		addr++;
	}
}

/*
	文字列の長さ
*/
byte strlength(byte *addr) {
	byte count;
	
	count = 0;
	
	while (*addr != 0x00) {
		count++;
		addr++;
	}
	
	return count;
}	

/*
	乱数発生
 */

/*
 Linear congruential generator - Wikipedia, the free encyclopedia
 http://en.wikipedia.org/wiki/Linear_Congruential_Generators
 
 Xn+1 = (aXn + c) mod m
 
 a = 287
 c = 1
 m = 65536 (0x10000)

0-255 の値を返す

random() % 0 にならないように注意

*/

byte random() {
	word a, c;
	word xn, xn1;
	byte ret;
	
	a = 287;
	c = 1;
	xn = _seed;
	xn1 = a*xn + c;
	
	_seed = xn1;
	
	ret = xn1;
	
	return ret;
}

/*
	疑似乱数 seed を設定
*/
byte srandom(word seed) {
	
	_seed = seed;
	
	return random();
}

/*
	画面消去
 */
void cls() {
	byte space = ' ';
	byte x, y;
	
	for (x=0; x<24; x++) {
		for (y=0; y<6; y++) {
			printchar(x, y, space);
		}
	}
}

/*
	データ表示

	表示位置は setLocate(x,y) で指定
	データを表示すると自動的に表示位置が増加する。
*/

/*
	BYTE データを10進数表示
 */
void printByte(byte data) {
	byte d0, d1, d2;
	
	d2 = data / 100;
	d1 = (data - d2*100) / 10;
	d0 = data - d2*100 - d1*10;
	
	printNibbleHex(d2);
	printNibbleHex(d1);
	printNibbleHex(d0);
}

/*
	WORD データを10進数で表示
*/
void printWord(word data) {
	word d[5];
	
	d[4] = data / 10000;
	d[3] = (data - d[4]*10000) / 1000;
	d[2] = (data - d[4]*10000 - d[3]*1000) / 100;
	d[1] = (data - d[4]*10000 - d[3]*1000 - d[2]*100) / 10;
	d[0] =  data - d[4]*10000 - d[3]*1000 - d[2]*100 - d[1]*10;
	
	printNibbleHex(d[4]);
	printNibbleHex(d[3]);
	printNibbleHex(d[2]);
	printNibbleHex(d[1]);
	printNibbleHex(d[0]);
}

/*
	16進数表示
*/

/*
	4ビットデータ(ニブル)を16進数表示
*/
void printNibbleHex(byte data) {
	byte hex[] = "0123456789ABCDEF";	
	byte low;
	
	low = data & 0x0f;
	
	printchar(_locate_x ,_locate_y, hex[low]);
	_calc();
}

/*
	BYTE データを16進数表示
*/
void printByteHex(byte data) {
	byte high;
	byte low;

	high = low = data;
	
	high = high & 0xf0;
	high = high >> 4;

	printNibbleHex(high);
	
	low = low & 0x0f;

	printNibbleHex(low);

}

/*
	WORD データを 16 進数で表示
*/
void printWordHex(word data) {
	word temp;
	byte high;
	byte low;
	
	temp = data;
	high = (byte)((temp & 0xff00) >> 8);
	low = (temp & 0x00ff);

	printByteHex(high);
	printByteHex(low);
}

/*
	表示位置の計算
*/
void _calc() {
	_locate_x++;
	if (_locate_x > 23) {
		_locate_x = 0;
		_locate_y++;
		if (_locate_y > 5) {
			_locate_y = 0;
			cls();
		}
	}	
}
